"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var indexes_exports = {};
__export(indexes_exports, {
  indexHasField: () => indexHasField,
  indexToEANPart: () => indexToEANPart,
  indexToEAVPart: () => indexToEAVPart,
  indexToUpdateExpressionPart: () => indexToUpdateExpressionPart
});
module.exports = __toCommonJS(indexes_exports);
var import_helpers = require("./helpers");
function indexHasField(name, primaryKey, index) {
  if (index.type === "lsi") {
    return primaryKey.partitionKeyFields.some((field) => field.fieldName === name) || index.sortKeyFields.some((field) => field.fieldName === name);
  }
  if (index.isComposite) {
    return index.partitionKeyFields.some((field) => field.fieldName === name) || index.sortKeyFields.some((field) => field.fieldName === name);
  }
  return index.partitionKeyFields.some((field) => field.fieldName === name);
}
function indexToUpdateExpressionPart(index) {
  const fields = [];
  const { type } = index;
  if (type === "gsi") {
    const { isComposite } = index;
    if (index.name !== index.partitionKeyName) {
      fields.push(index.partitionKeyName);
    }
    if (isComposite) {
      if (index.name !== index.sortKeyName) {
        fields.push(index.sortKeyName);
      }
    }
  }
  if (type === "lsi") {
    if (index.name !== index.sortKeyName) {
      fields.push(index.sortKeyName);
    }
  }
  return fields.map((field) => `'#${field} = :${field}',`);
}
function indexToEAVPart(mode, index) {
  const fields = [];
  const { type } = index;
  if (type === "gsi") {
    const { isComposite } = index;
    if (index.name !== index.partitionKeyName) {
      fields.push(
        `':${index.partitionKeyName}': ${(0, import_helpers.makeKeyTemplate)(
          index.partitionKeyPrefix,
          index.partitionKeyFields,
          mode
        )},`
      );
    }
    if (isComposite) {
      if (index.name !== index.sortKeyName) {
        fields.push(
          `':${index.sortKeyName}': ${(0, import_helpers.makeKeyTemplate)(
            index.sortKeyPrefix,
            index.sortKeyFields,
            mode
          )},`
        );
      }
    }
  }
  if (type === "lsi") {
    fields.push(
      `':${index.sortKeyName}': ${(0, import_helpers.makeKeyTemplate)(
        index.sortKeyPrefix,
        index.sortKeyFields,
        mode
      )},`
    );
  }
  return fields;
}
function indexToEANPart(config, index) {
  const fields = [];
  const { type } = index;
  if (type === "gsi") {
    const { isComposite } = index;
    if (index.name !== index.partitionKeyName) {
      fields.push(index.partitionKeyName);
    }
    if (isComposite) {
      if (index.name !== index.sortKeyName) {
        fields.push(index.sortKeyName);
      }
    }
  }
  if (type === "lsi") {
    if (index.name !== index.sortKeyName) {
      fields.push(index.sortKeyName);
    }
  }
  return fields.map((field) => `'#${field}': '${field}',`);
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  indexHasField,
  indexToEANPart,
  indexToEAVPart,
  indexToUpdateExpressionPart
});
