"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var unmarshall_exports = {};
__export(unmarshall_exports, {
  DIVIDER: () => DIVIDER,
  unmarshallTpl: () => unmarshallTpl
});
module.exports = __toCommonJS(unmarshall_exports);
var import_computed_fields = require("../computed-fields");
var import_helpers = require("./helpers");
const DIVIDER = "#:#";
function unmarshallTpl({ fields, primaryKey, typeName }) {
  const requiredFields = fields.filter((f) => f.isRequired).filter(({ computeFunction }) => !computeFunction?.isVirtual);
  const optionalFields = fields.filter((f) => !f.isRequired).filter(({ computeFunction }) => !computeFunction?.isVirtual);
  return `
/** Unmarshalls a DynamoDB record into a ${typeName} object */
export function unmarshall${typeName}(item: Record<string, any>): ${typeName} {

  let result: ${typeName} = {
${requiredFields.map((field) => {
    if (field.fieldName === "id") {
      if (primaryKey.isComposite) {
        return `id: Base64.encode(\`${typeName}:\${item.pk}${DIVIDER}\${item.sk}\`)`;
      }
      return `id: Base64.encode(\`${typeName}:\${item.pk}\`)`;
    }
    return (0, import_helpers.unmarshallField)(field);
  })}
  };

${optionalFields.map((field) => {
    if (field.isDateType) {
      return `  if (${field.columnNamesForRead.map((c) => `('${c}' in item) && item.${c} !== null`).join("||")}) {
    result = {
      ...result,
      ${(0, import_helpers.unmarshallField)(field)}
    }
  }`;
    }
    return `  if (${field.columnNamesForRead.map((c) => `('${c}' in item)`).join("||")}) {
    result = {
      ...result,
      ${(0, import_helpers.unmarshallField)(field)}
    }
  }`;
  }).join("\n")}

  ${(0, import_computed_fields.defineComputedOutputFields)(fields)}

  return result;
}
`;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DIVIDER,
  unmarshallTpl
});
