import { makeKeyTemplate } from "./helpers";
function indexHasField(name, primaryKey, index) {
  if (index.type === "lsi") {
    return primaryKey.partitionKeyFields.some((field) => field.fieldName === name) || index.sortKeyFields.some((field) => field.fieldName === name);
  }
  if (index.isComposite) {
    return index.partitionKeyFields.some((field) => field.fieldName === name) || index.sortKeyFields.some((field) => field.fieldName === name);
  }
  return index.partitionKeyFields.some((field) => field.fieldName === name);
}
function indexToUpdateExpressionPart(index) {
  const fields = [];
  const { type } = index;
  if (type === "gsi") {
    const { isComposite } = index;
    if (index.name !== index.partitionKeyName) {
      fields.push(index.partitionKeyName);
    }
    if (isComposite) {
      if (index.name !== index.sortKeyName) {
        fields.push(index.sortKeyName);
      }
    }
  }
  if (type === "lsi") {
    if (index.name !== index.sortKeyName) {
      fields.push(index.sortKeyName);
    }
  }
  return fields.map((field) => `'#${field} = :${field}',`);
}
function indexToEAVPart(mode, index) {
  const fields = [];
  const { type } = index;
  if (type === "gsi") {
    const { isComposite } = index;
    if (index.name !== index.partitionKeyName) {
      fields.push(
        `':${index.partitionKeyName}': ${makeKeyTemplate(
          index.partitionKeyPrefix,
          index.partitionKeyFields,
          mode
        )},`
      );
    }
    if (isComposite) {
      if (index.name !== index.sortKeyName) {
        fields.push(
          `':${index.sortKeyName}': ${makeKeyTemplate(
            index.sortKeyPrefix,
            index.sortKeyFields,
            mode
          )},`
        );
      }
    }
  }
  if (type === "lsi") {
    fields.push(
      `':${index.sortKeyName}': ${makeKeyTemplate(
        index.sortKeyPrefix,
        index.sortKeyFields,
        mode
      )},`
    );
  }
  return fields;
}
function indexToEANPart(config, index) {
  const fields = [];
  const { type } = index;
  if (type === "gsi") {
    const { isComposite } = index;
    if (index.name !== index.partitionKeyName) {
      fields.push(index.partitionKeyName);
    }
    if (isComposite) {
      if (index.name !== index.sortKeyName) {
        fields.push(index.sortKeyName);
      }
    }
  }
  if (type === "lsi") {
    if (index.name !== index.sortKeyName) {
      fields.push(index.sortKeyName);
    }
  }
  return fields.map((field) => `'#${field}': '${field}',`);
}
export {
  indexHasField,
  indexToEANPart,
  indexToEAVPart,
  indexToUpdateExpressionPart
};
