import type { Field, Model } from '@code-like-a-carpenter/foundation-intermediate-representation';
/** Indicates if this model has any computed fields */
export declare function hasComputedFields(model: Model): boolean;
/**
 * Returns the input name for this model. If the model has computed fields,
 * it'll need to be renamed so that other templates can manipulate "input".
 */
export declare function inputName(model: Model): "_input" | "input";
/**
 * Uses Object.defineProperty to add computed fields to `input` so that
 * order-of-access doesn't matter.
 */
export declare function defineComputedInputFields(fields: readonly Field[], typeName: string): string;
/**
 * Uses Object.defineProperty to add computes fields to the database result  so
 * that order-of-access doesn't matter.
 */
export declare function defineComputedOutputFields(fields: readonly Field[]): string;
//# sourceMappingURL=computed-fields.d.ts.map